<?php
$mailservers=array("mailsrv1","mailsrv2");
$user="admin";
$queue_cmd="/usr/sbin/postqueue";
$message_cmd="/usr/sbin/postsuper";
//$wrapper_cmd="/path/to/mailqueue.sh";
$show_cmd="/usr/sbin/postcat";
$sudo_cmd="/usr/bin/sudo";

$selection=$_GET['selected'];
$mailaddr=$_GET['mailaddr'];
$action=$_GET['action'];
$server=$_GET['mailhost'];

if ($action == "download") {
  $output = shell_exec("/usr/bin/ssh $user@$server '" . $sudo_cmd . " -n " . $show_cmd . " -hb -q " . $selection . " 2>&1'");
  header('Content-Type: application/octet-stream');
  header("Content-Transfer-Encoding: Binary");
  header("Content-disposition: attachment; filename=\"" . $selection . ".eml" . "\"");
  echo "$output";
  exit();
}
?>

<html>
<head>
<link rel='stylesheet' type='text/css' href='style.css'>
<title>Mail Queue Manager</title>
<meta http-equiv="refresh" content="30; URL=<?php echo 'index.php?selected=' . $selection . '&mailaddr=' . $mailaddr . '&mailhost=' . $server; ?>">

<script type="text/javascript">
function popup (url) {
 fenster = window.open(url, "Queue Action", "width=600,height=300,resizable=yes");
 fenster.focus();
 return false;
}
</script>

</head>

<body>

<h1>Mail Queue Manager</h1>

<?php

if ($selection != "") {
?>
<form action = '<?echo $_SERVER['PHP_SELF'] ?>' method='get'>
  Action for <b><?echo $selection ?></b>:<br>
  <table>
  <tr>
  <td>Hold</td><td><input type='radio' name='action' value='hold'></td>
  </tr><tr>
  <td>Release</td><td><input type='radio' name='action' value='release'></td>
  </tr><tr>
  <td>Remove</td><td><input type='radio' name='action' value='remove'></td>
  </tr><tr>
  <td>Requeue</td><td><input type='radio' name='action' value='requeue'></td>
  </tr><tr>
  <td>Expire</td><td><input type='radio' name='action' value='expire'></td>
  </tr><tr>
  <td>Download</td><td><input type='radio' name='action' value='download'></td>
  </tr>
  </table>
  <br>&nbsp;<br>
  <input type='submit' value='Do it!'>
  <input type='reset' value='Leave it!'>
  <input type='hidden' name='selected' value='<?echo $selection ?>'>
  <input type='hidden' name='mailhost' value='<?echo $server ?>'>
</form>
<?
} elseif ($mailaddr != "") {
?>
<form action = '<?echo $PHP_SELF ?>' method='get'>
	Action for all entries with e-mail address <b><?echo $mailaddr ?></b> on server <b><?echo $server ?></b>:<br>
  <table>
  <tr>
  <td>Remove</td><td><input type='radio' name='action' value='remove'></td>
  </tr><tr>
  <td>Requeue</td><td><input type='radio' name='action' value='requeue'></td>
  </tr>
  </table>
  <br>&nbsp;<br>
  <input type='submit' value='Do it!'>
  <input type='reset' value='Leave it!'>
  <input type='hidden' name='mailaddr' value='<?echo $mailaddr ?>'>
  <input type='hidden' name='mailhost' value='<?echo $server ?>'>
</form>
<?
} else {
  foreach ($mailservers as $server) {
    echo "<h2>$server</h2>";
    $output = shell_exec("/usr/bin/ssh $user@$server '" . $queue_cmd . " -p'");
    if ($wrapper_cmd) {
      $output = preg_replace('%^([A-F0-9]+.+?)([\w.-]+@[\w.-]+)%m','$1<a href="index.php?mailaddr=$2&mailhost=' . $server . '"  onClick="return popup(this.href);">$2</a>',$output);
      $output = preg_replace('%^([A-F0-9]+.+?)(MAILER-DAEMON)%m','$1<a href="index.php?mailaddr=$2&mailhost=' . $server . '"  onClick="return popup(this.href);">$2</a>',$output);
    }
    $output = preg_replace('%^([A-F0-9]+)%m','<a href="index.php?selected=$1&mailhost=' . $server . '"  onClick="return popup(this.href);">$1</a>',$output);
    echo "<pre>$output</pre>";
  }
}

if ($selection != "") {
	if ($action == "hold") {
	  $output = shell_exec("/usr/bin/ssh $user@$server '" . $sudo_cmd . " -n " . $message_cmd . " -h " . $selection . " 2>&1'");
	  echo "<pre>$output</pre>";
	} else if ($action == "release") {
	  $output = shell_exec("/usr/bin/ssh $user@$server '" . $sudo_cmd . " -n " . $message_cmd . " -H " . $selection . " 2>&1'");
	  echo "<pre>$output</pre>";
	} else if ($action == "remove") {
	  $output = shell_exec("/usr/bin/ssh $user@$server '" . $sudo_cmd . " -n " . $message_cmd . " -d " . $selection . " 2>&1'");
	  echo "<pre>$output</pre>";
	} else if ($action == "requeue") {
	  $output = shell_exec("/usr/bin/ssh $user@$server '" . $sudo_cmd . " -n " . $message_cmd . " -r " . $selection . " 2>&1'");
	  echo "<pre>$output</pre>";
	} else if ($action == "expire") {
	  $output = shell_exec("/usr/bin/ssh $user@$server '" . $sudo_cmd . " -n " . $message_cmd . " -e " . $selection . " 2>&1'");
	  echo "<pre>$output</pre>";
  }
} elseif ($mailaddr != "") {
	if ($action == "remove") {
	  $output = shell_exec("/usr/bin/ssh $user@$server '" . $sudo_cmd . " -n " . $wrapper_cmd . " -d " . $mailaddr . " 2>&1'");
	  echo "<pre>$output</pre>";
   }
	if ($action == "requeue") {
	  $output = shell_exec("/usr/bin/ssh $user@$server '" . $sudo_cmd . " -n " . $wrapper_cmd . " -r " . $mailaddr . " 2>&1'");
	  echo "<pre>$output</pre>";
   }
} elseif ($action == "flush") {
	foreach ($mailservers as $server) {
	  $output = shell_exec("/usr/bin/ssh $user@$server '" . $sudo_cmd . " -n " . $queue_cmd . " -f'");
	  echo "<pre>$output</pre>";
	}
}

?>
<br>
<?
if ( ($selection == "") && ($mailaddr == "") ) {
?>
<input type="button" value="Reload Page" onClick="window.location.reload()">
<input type="button" value="Requeue All Messages" onClick="window.location.href = '<?echo $_SERVER['PHP_SELF'] ?>?action=flush'">
<?
} else {
?>
<input type="button" value="Close this Window" onClick="window.close()">
<?
}
?>
</body>
</html>
