#! /bin/bash
if [ "$1" != "-d" ] && [ "$1" != "-r" ] || [ "$2" == "" ]; then
  echo "Usage: [-d|-r] <e-mail address>"
  echo "       -d purges all messages with given e-mail address"
  echo "       -r requeues all messages with given e-mail address"
  exit 1
else
  op=$1
  emailaddr=$2
fi

for id in `mailq | egrep "[0-9A-F]{10} " | grep "$emailaddr" | cut -d " " -f 1`
do
  postsuper $op $id
done
